'TMX Explorer 1.0
'Browse BIN, TMX, CVM, or SPR files and extract images to PNG
'by Blyss
'August 2, 2010
'TMX reading code heavily based on code by PersonaRipper and bbrcher @ Xentax forums
'FreeBASIC PNG Library (v1.9.2)  Copyright (C) 2007-2009 Simon Nash  zlib code Copyright (C) 1995-2005 Jean-loup Gailly and Mark Adler
'Thanks to bcohio2001 @ Freebasic forums for directory/file reading code
#Include Once "fbpng.bi"
#Include Once "file.bi"
#Include Once "fbgfx.bi"
Using fb
#Undef Lof 'because regular LOF does not seem to work right with large files
'this will be used for palettes
Type Clr
	r As UByte
	g As UByte
	b As UByte
	a As UByte
End Type

'stores tmx data
Type tmxFile
	sigStart As Integer '0x02
	fileSize As Integer
	Sig(1 To 4) As UByte 'TMX0
	W As Short 'Width
	H As Short 'Height
	Flags As Integer 'Palette size flag
	palSize As Integer = 256
End Type
Dim Shared As tmxFile tmx
Dim Shared As Integer curFile = 1, lastfile, deep = 1, bpp
Dim Shared As ULongInt possave, quicksearch(1 To 10000), lof
Dim Shared As String fileArray(1 To 3000), filename, outfile
Dim Shared As Any Ptr curimg
Declare Sub cleanupandexit
Declare Sub changedir
Declare Sub loadfiles
Declare Sub renderTMX
Declare Sub about
Declare Sub Clearquicksearch
ScreenRes 1000, 700, 32
Color RGB(255,255,255)
loadfiles
renderit:
If curimg Then ImageDestroy(curimg)
Cls
'Don't try to read files that don't exist!
If curfile < 1 Then curfile = lastfile
If curfile > lastfile Then curfile = 1
Close #1
renderTMX
'The whole point of this... let the user see what the TMX looks like!
Put (1,1),curimg, Alpha

'File info etc
Locate 85,1: Print "Directory of: " & CurDir
Locate 37,70: Print "Filename: " & fileArray(curfile)
Locate 39,70: Print "File: " & curfile & " of " & lastfile
Locate 41,70: Print "Size: " & tmx.filesize & " bytes. Color depth: " & bpp & " bpp"
Locate 43,70: Print deep & " files deep"
Locate 45, 70: Print "Up/Down - move through files by 1"
Locate 47, 70: Print "Page Up/PageDown - move through files by 10"
Locate 49,70: Print "S moves you deeper into a BIN, W moves you back"
Locate 51, 70: Print "D to enter directory change mode"
Locate 53,70: Print "Enter to save a PNG, Escape to exit, Space for About"


'Traps key input, also main loop
Do
	If MultiKey (SC_DOWN) Then
		Clearquicksearch
		curfile+ = 1
		Sleep 100,1
		deep = 1
		possave = 0
		GoTo renderit
	EndIf
	If MultiKey (SC_UP) Then
		Clearquicksearch
		curfile- = 1
		Sleep 100,1
		deep = 1
		possave = 0
		GoTo renderit
	EndIf

	If MultiKey (SC_S) AndAlso UCase(Right(filearray(curfile),4)) <> ".TMX" Then
		Sleep 100,1
		deep + = 1
		If quicksearch(deep) <> 0 Then
			possave = quicksearch(deep)
		Else possave+=tmx.filesize
		EndIf
		GoTo renderit
	EndIf

	If MultiKey (SC_W) AndAlso UCase(Right(filearray(curfile),4)) <> ".TMX" Then
		Sleep 100,1
		deep - = 1
		If deep = 0 Then
			possave = quicksearch(1)
			deep = 1
		Else
			possave = quicksearch(deep)
		EndIf
		GoTo renderit
	EndIf

	If MultiKey (SC_PAGEDOWN) Then
		Clearquicksearch
		curfile+=10
		Sleep 100,1
		deep = 1
		GoTo renderit
	EndIf

	If MultiKey (SC_PAGEUP) Then
		Clearquicksearch
		curfile-=10
		Sleep 100,1
		deep = 1
		GoTo renderit
	EndIf

	If MultiKey(SC_SPACE) Then
		While MultiKey(SC_SPACE): Sleep 1: wend
		about
		GoTo renderit
	EndIf
	
	If MultiKey(SC_D) Then
		changedir
		GoTo renderit
	EndIf
	
	If MultiKey(SC_ENTER) Then
		outfile = ExePath & "/" & filearray(curfile) & "_" & deep
		While FileExists(outfile & ".png")
			outfile = outfile & "_"
		Wend
		png_save(outfile & ".png", curimg)
		Color RGB(0,255,0)
		Locate 86, 0: Print "Saved: " & outfile & ".png"
		Color RGB(255,255,255)
		Sleep 700,1
	EndIf
	Sleep 50
Loop While Not MultiKey(SC_ESCAPE)
cleanupandexit


Sub renderTMX
	'go back to here if EOF(1) and user navigates "Deeper", i.e. loop back to start of file
	rendertop:
	Dim As Integer offset=1, bc
	Lof = FileLen(filearray(curfile))
	Dim As ULongInt datachunk = cint(Lof / 200), xsearch = possave
	Dim As UByte bigsearch(datachunk-1)
	If Lof = 0 Then GoTo Notmx
	Open fileArray(curfile) For Binary As #1
	'This searches the file for TMX signature, reading in .5% chunks, so memory usage is LOF * .005
	Print "Reading: " & filearray(curfile)
	If UCase(Right(filearray(curfile),4)) <> ".TMX" Then
		For xsearch = xsearch To Lof Step datachunk
			If MultiKey(SC_ESCAPE) Then
				cleanupandexit
			EndIf
			Get #1, xsearch, bigsearch()
			For bc = 0 To datachunk-1 Step 1
				If bigsearch(bc) = Asc("T") Andalso bigsearch(bc+1) = Asc("M") AndAlso bigsearch(bc+2) = Asc("X") Andalso bigsearch(bc+3) = Asc("0") Then
					xsearch+=bc
					GoTo gotAtmx
				EndIf
			Next
		Next
		'this loops back if in a container file and navigate past EOF... usually
		If xsearch >= Lof And deep > 1 Then
			deep = 1
			possave = 0
			Close #1
			GoTo rendertop
		EndIf
		
		gotaTMX:
		Cls
		quicksearch(deep) = xsearch ' set the quicksearch value which saves on lookup time for previously found images
		offset = xsearch - 8' since we search for the TMX sig and not the file start, offset back to the start
	EndIf
	possave = xsearch ' save current file position
	If filename = "" Then filename = filearray(curfile)
	notmx:
	' Hex numbers are where the data is in a single TMX file, offset corrects it for container files.
	' Much of this bit is based on PersonaRipper and bbrchers C code for extracting TMX, in fact 95% of it
	
	'This strange searching is because the main search above seems to get offset by 1 byte from time to time
	'and when it does, it can cause crashes and hanging and all kinds of insaneness. This should completely
	'fix it, but just in case it has a failsafe to prevent strange occurances. It would also catch cases
	'where a file is of valid extensions but invalid type, so I guess it's not COMPLETELY a hack.	
	Get #1, offset, tmx.sigStart
	If tmx.sigstart <> &h02 Then
		For offset = offset To offset + 10 Step 1
			Get #1, offset, tmx.sigStart
			If tmx.sigstart = &h02 Then Exit for
		Next
	End if
	If tmx.sigstart <> &h02 Then
		For offset = offset - 10 To offset-20
			Get #1, offset, tmx.sigStart
			If tmx.sigstart = &h02 Then Exit For
		Next
	EndIf
	If tmx.sigstart <> &h02 Then
		Cls
		Print "Fatal error. Unable to find TMX signature. Exit in 5 seconds."
		Sleep 5000,1
		cleanupandexit
	EndIf
	
	'Read header
	Get #1, offset+&h08, tmx.sig()
	Get #1, offset+&h04, tmx.filesize
	Get #1, offset+&h12, tmx.W
	Get #1, offset+&h14, tmx.H
	Get #1, offset+&h16, tmx.Flags
	If tmx.Flags = &h14 Then tmx.palsize = 16 Else tmx.palsize = 256
	Dim As Integer i = 0, alph = 0, a=550, b = 0, q
	Dim As Integer datasize = CInt(tmx.w) * CInt(tmx.h)
	Dim As Byte tmxdata(datasize)
	Dim As Integer j = 0, k = tmx.h-1, idx = 0, outd =0, dataWidth = tmx.w
	Dim As clr Pal(tmx.palsize)
	Dim As Integer x = 0, y = tmx.h
	curimg = ImageCreate(tmx.w,tmx.h,RGBA(0,0,0,0))
	
	If tmx.palsize = 16 Then
		bpp = 4
		datasize/ = 2
		datawidth/ = 2
		Get #1, offset+&H80, tmxdata()
	ElseIf tmx.palsize = 256 Then
		Get #1, offset+&H440, tmxdata()
	End If
	
	'Get Palette
	Get #1, offset+&h40, pal()

	'Tile palette
	' 1 = 1, 2 = 3, 3 = 2, 4 = 4
	' do that 8 times
	If tmx.palsize = 256 Then
		bpp = 8
		Dim As clr tpal(tmx.palsize)
		Dim As Integer p = 1
		For i = 0 To 256
			tpal(i) = pal(i)
		Next

		Dim As Integer iadd = 0
		For iadd = 0 To 256-32 Step 32
			For i = 0+iadd To 7+iadd
				'first 8
				pal(i) = tpal(i)
			Next
			For i = 8+iadd To 15+iadd
				'second 8
				pal(i) = tpal(i+8)
			Next

			For i = 16+iadd To 23+iadd
				'third 8
				pal(i) = tpal(i-8)
			Next

			For i = 24+iadd To 31+iadd
				'fourth 8
				pal(i) = tpal(i)
			Next
		Next
	End If

	'alpha scaling, does this even do anything? I dunno if I even translated it from C right
	For i = 0 To tmx.palsize  Step 1
		alph = CInt(255.0f) * ( CDbl(pal(i).a) / 128.0f)
		If alph > 255 Then pal(i).a = 255 Else pal(i).a = alph
	Next

	'render the palette, made this to help me learn how to tile it, but it seems useful so it stays
	For i = 0 To tmx.palsize-1
		For q = 0 To 15 Step 1
			Line (a,b+q)-(a+16,b+q), RGBA(pal(i).r, pal(i).g, pal(i).b, pal(i).a)
		Next
		a+ =16
		If a = 806 Then a = 550: b = b + 16: EndIf
	Next

	'Render image to the buffer
	While k >=0
		j = 0
		While j < datawidth
			idx = k * datawidth + j
			If tmx.palsize = 16 Then
				'4 bits per pixel, I'm not even sure how this works but it does!
				outd = tmxdata(idx) And &H0f
				PSet curimg, (x, y), RGBA(pal(outd).r, pal(outd).g, pal(outd).b, pal(outd).a)
				x+=1:If x = tmx.w Then x = 0: y-=1: End If
				outd = (tmxdata(idx) And &hF0) Shr 4
				PSet curimg, (x, y), RGBA(pal(outd).r, pal(outd).g, pal(outd).b, pal(outd).a)
				x+=1:If x = tmx.w Then x = 0: y-=1: End If
			Else
				'8 bits per pixel
				outd = CUByte(tmxdata(idx))
				PSet curimg, (x, y), RGBA(pal(outd).r, pal(outd).g, pal(outd).b, pal(outd).a)
				x+=1:If x = tmx.w Then x = 0: y-=1: End If
			End If
			j+ = 1
		Wend
		k- =1
	Wend
End Sub

Sub about
	Cls
	Print "TMX Explorer version 1.0 by Blyss"
	Print
	Print "TMX reading code strongly based on PersonaRipper and bbrcher's code found on Xentax forums"
	Print
	Print "Thanks to bcohio2001 @ Freebasic forums for directory/file reading code"
	Print
	Print "FreeBASIC PNG Library (v1.9.2)  Copyright (C) 2007-2009 Simon Nash"
	Print
	Print "zlib code Copyright (C) 1995-2005 Jean-loup Gailly and Mark Adler"
	Print
	Print "Capabilities:"
	Print
	Print "Visually scan TMX graphics files or BIN, SPR, CVM files that contain TMX files and directly export to PNG"
	Print
	Print "The code is now as optimized as I can make it, and is pretty fast even in 3GB CVM files."
	Print
	Print "Compatibility:"
	Print
	Print "*.BIN and/or *.TMX and/or *.CVM and/or *.SPR files from Persona 3 and Persona 4, as well as any game that uses the format."
	Print
	Print "Compatible with 4 bpp (16 color) and 8 bpp (256 color) TMX graphics files. If 16, 24 or 32 bpp"
	Print
	Print "TMX files exist, this application will not read them (yet!). If you find one tell me!"
	Print
	Print "Hope it's useful. ~Blyss"
	Print
	Print "Send comments and compatibility reports to: squall4226@bellsouth.net and include subject line ""TMX Explorer"""
	Print
	Print "Compiled on: " + Str(__DATE__) + " at " + Str(__TIME__)
	Print
	Print "Compiled with FreeBASIC version " + Str(__FB_VER_MAJOR__) + "." + Str(__FB_VER_MINOR__) + "." + Str(__FB_VER_PATCH__)
	Print
	Print
	Color RGB(255,0,255)
	Print "Press space to return."
	Color RGB(255,255,255)
	While Not MultiKey(SC_SPACE): Sleep 1: Wend
	While MultiKey(SC_SPACE): Sleep 1: wend		
End Sub


Sub loadfiles
	parse:
	Dim As Integer i = 1, a
	Dim As String f
	'clear the array
	For i = 1 To 3000
		filearray(i) = ""
	Next
	i= 1
	F = Dir("*",32,@A)
	While F <> ""
		If UCase(Right(F,4)) = ".TMX" Or UCase(Right(F,4)) = ".BIN" Or UCase(Right(F,4)) = ".CVM" Or UCase(Right(F,4)) =".SPR" Or UCase(Right(F,4)) = ".ISO" Then
			filearray(i) = f
			i+=1
		EndIf
		F = Dir(A)
	Wend

	If i = 1  Then
		Cls
		Print "No TMX files found in the current directory. Please select a new one."
		Sleep 2000,1
		changedir
		GoTo parse
	EndIf
	lastfile = i -1
	curfile = 1
End Sub

Sub changedir
	'this is a bit messy
	possave = 0
	clearquicksearch
	top:
	Dim As String F
	Dim As String listofdirs(1 To 100), listoffiles(1 To 100), olddir, drivechoice
	Dim As UInteger dirind = 1, maxdirs, dirsel = 2, fileind=1
	Dim As Integer a
	'Get list of directories
	F = Dir("*",23,@A) 'DHSR
	While F <> ""
		If (A And 16) = 16 Then
			listofdirs(dirind) = F
			dirind+=1
		EndIf
		F = Dir(A)
	Wend
	maxdirs = dirind - 1
	'Determine what files are in directory
	filerefresh:
	olddir = CurDir
	ChDir listofdirs(dirsel)
	For fileind=1 To 100
		listoffiles(fileind)=""
	Next
	fileind=1
	F = Dir("*",32,@A)
	While F <> ""
		If UCase(Right(F,4)) = ".TMX" Or UCase(Right(F,4)) = ".BIN" Or UCase(Right(F,4)) = ".CVM" Or UCase(Right(F,4)) = ".SPR" Or UCase(Right(F,4)) = ".ISO" Then
			listoffiles(fileind) = f
			fileind+=1
		EndIf
		F = Dir(A)
		If fileind = 3 Then Exit While
	Wend
	ChDir olddir
	'Display output
	Cls
	Print "Directory Index of:"
	Print
	Print CurDir
	Print "________________"
	Print
	For dirind = 1 To maxdirs Step 1
		If Dirind = dirsel Then
			Print listofdirs(dirind) & " <--"
		Else
			Print listofdirs(dirind)
		End If
	Next
	Print
	Print "+++++++++"
	Print
	If listoffiles(1) <> "" Then
		Color RGB(0,255,0)
		Print "This directory contains readable files."
	Else
		Color RGB(255,0,0)
		Print "This directory does not contain readable files."
	EndIf
	Color RGB(255,255,255)
	Locate 78, 70: Print "Up/Down - Navigate"
	Locate 80, 70: Print "Space - Browse to new directory"
	Locate 82, 70: Print "V - Change drive"
	Locate 84, 70: Print "Enter - Confirm choice and return to graphic display"
	Locate 86, 70: Print "Escape - Quit"
	'Trap keys for navigation
	Do
		If MultiKey(SC_V) Then
			While MultiKey(SC_V) Or InKey$ = "v": Sleep 1: Wend
			Cls
			Print "Type a drive/volume to change to in the format C:"
			Input "", drivechoice
			ChDir drivechoice
			While MultiKey(SC_ENTER): Sleep 1: Wend
			GoTo top
		EndIf
		If MultiKey(SC_UP) Then
			dirsel-=1
			If dirsel=0 Then dirsel = maxdirs
			Sleep 200,1
			GoTo filerefresh
		EndIf
		If MultiKey(SC_DOWN) Then
			Dirsel+=1
			If dirsel > maxdirs Then dirsel = 1
			Sleep 200,1
			GoTo filerefresh
		EndIf
		If MultiKey(SC_SPACE) Then
			While MultiKey(SC_SPACE): Sleep 1,1: Wend
			ChDir listofdirs(dirsel)
			GoTo top
		EndIf

		If MultiKey(SC_ENTER)Then
			While MultiKey(SC_ENTER): Sleep 1,1: Wend
			If listoffiles(1) <> "" Then
				ChDir listofdirs(dirsel)
				loadfiles
				Return
			Else
				Locate 51,15
				Color RGB(255,255,0)
				Print "You may not select this directory since it does not contain TMX graphics files or containers!"
				Color RGB(255,255,255)
			End If
		End If
		If MultiKey(SC_ESCAPE) Then
			cleanupandexit
		EndIf
		Sleep 10
	Loop
End Sub

Sub Clearquicksearch
	Dim As Integer b
	For b = 1 To 10000
		quicksearch(b) = 0
	Next
End Sub

Sub cleanupandexit
	If curimg then ImageDestroy(curimg)
	Close
	End
End Sub
